%define mod_name mod_suexec
%define mod_conf 69_%{mod_name}.conf
%define mod_so %{mod_name}.so
%define sourcename %{mod_name}-%{apache_version}

Summary:	Allows CGI scripts to run as a specified user and Group
Name:		apache-%{mod_name}
Version:	2.2.22
Release:	%mkrel 1
Group:		System/Servers
License:	Apache License
URL:		http://httpd.apache.org/docs/suexec.html
Source1:	%{mod_conf}
Requires(pre): rpm-helper
Requires(postun): rpm-helper
Requires(pre):  apache >= %{version}
Requires:	apache >= %{version}
BuildRequires:  apache-devel >= %{version}
BuildRequires:  apache-source >= %{version}

%description
This module, in combination with the suexec support program
allows CGI scripts to run as a specified user and Group.

Normally, when a CGI or SSI program executes, it runs as the
same user who is running the web server.

%post
if [ -f %{_var}/lock/subsys/httpd ]; then
    %{_initrddir}/httpd restart 1>&2;
fi

%postun
if [ "$1" = "0" ]; then
    if [ -f %{_var}/lock/subsys/httpd ]; then
        %{_initrddir}/httpd restart 1>&2
    fi
fi

%files
%defattr(-,root,root)
%doc mod_suexec.html suexec.html README.mga
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/httpd/modules.d/%{mod_conf}
%attr(0755,root,root) %{_libdir}/apache/%{mod_so}
%attr(4710,root,apache) %{_sbindir}/suexec
%{_mandir}/man8/*

#--------------------------------------------------------------------

%prep

%setup -c -T -n %{name}

cp %{_includedir}/apache/*.h .
cp -rp `apr-1-config --includedir`/* .
cp -rp `apu-1-config --includedir`/* .

echo "#define AP_GID_MIN 100"  >> ap_config_auto.h
echo "#define AP_UID_MIN 100"  >> ap_config_auto.h
echo "#define AP_DOC_ROOT \"%{_var}/www\"" >> ap_config_auto.h
echo "#define AP_HTTPD_USER \"apache\""  >> ap_config_auto.h
echo "#define AP_LOG_EXEC \"%{_var}/log/httpd/suexec_log\""  >> ap_config_auto.h
echo "#define AP_SAFE_PATH \"/usr/local/bin:/usr/bin:/bin\""  >> ap_config_auto.h
echo "#define AP_SUEXEC_UMASK 0077"  >> ap_config_auto.h
echo "#define AP_USERDIR_SUFFIX \"public_html\""  >> ap_config_auto.h

cp %{_usrsrc}/apache-%{version}/docs/man/suexec.8 .
cp %{_usrsrc}/apache-%{version}/docs/manual/mod/mod_suexec.html.en mod_suexec.html
cp %{_usrsrc}/apache-%{version}/docs/manual/programs/suexec.html.en programs-suexec.html
cp %{_usrsrc}/apache-%{version}/docs/manual/suexec.html.en suexec.html
cp %{_usrsrc}/apache-%{version}/modules/generators/mod_suexec.c .
cp %{_usrsrc}/apache-%{version}/modules/generators/mod_suexec.h .
cp %{_usrsrc}/apache-%{version}/support/suexec.c .
cp %{_usrsrc}/apache-%{version}/support/suexec.h .

cp %{SOURCE1} %{mod_conf}

%build

gcc `%{_sbindir}/apxs -q CFLAGS -Wall` -D_REENTRANT -D_GNU_SOURCE -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -I. -o suexec suexec.c

%{_sbindir}/apxs -I. -c %{mod_name}.c

%install
install -d %{buildroot}%{_libdir}/apache
install -d %{buildroot}%{_sysconfdir}/httpd/modules.d
install -d %{buildroot}%{_sbindir}
install -d %{buildroot}%{_mandir}/man8

install -m0755 suexec %{buildroot}%{_sbindir}/suexec
install suexec.8 %{buildroot}%{_mandir}/man8/suexec.8

install -m0755 .libs/*.so %{buildroot}%{_libdir}/apache/
install -m0644 %{mod_conf} %{buildroot}%{_sysconfdir}/httpd/modules.d/%{mod_conf}


cat > README.mga << EOF
#!/bin/sh
# 
# This file shows how you can build a customised %{_sbindir}/suexec binary.
#
# It requires that you have additional development packages installed:
# urpmi apache-devel >= %{apache_version}
# urpmi apache-source >= %{apache_version}

gcc \`%{_sbindir}/apxs -q CFLAGS -Wall\` -D_REENTRANT -D_GNU_SOURCE -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE \\
    -I%{_includedir}/apache -I%{_usrsrc}/apache-%{version}/support \\
    \`apr-1-config --includes\` \`apu-1-config --includes\` \\
    -DAP_GID_MIN=100 -DAP_UID_MIN=100 -DAP_DOC_ROOT=\"/home\" -DAP_HTTPD_USER=\"apache\" \\
    -DAP_LOG_EXEC=\"%{_var}/log/httpd/suexec_log\" \\
    -DAP_SAFE_PATH=\"/usr/local/bin:/usr/bin:/bin\" \\
    -DAP_SUEXEC_UMASK=0077 -DAP_USERDIR_SUFFIX=\"public_html\" \\
    -o %{_sbindir}/suexec %{_usrsrc}/apache-%{version}/support/suexec.c

chown root:apache %{_sbindir}/suexec
chmod 4710 %{_sbindir}/suexec
%{_sbindir}/suexec -V

EOF



%changelog

* Mon Feb 13 2012 luigiwalser <luigiwalser> 2.2.22-1.mga1
+ Revision: 208289
- Import in Mageia 1

* Sun Feb 12 2012 luigiwalser <luigiwalser> 2.2.22-1.mga2
+ Revision: 207691
- 2.2.22

  + guillomovitch <guillomovitch>
    - rename distribution-specific file to README.mga

* Wed Dec 28 2011 dmorgan <dmorgan> 2.2.21-1.mga2
+ Revision: 188314
- imported package apache-mod_suexec


* Wed Sep 14 2011 Oden Eriksson <oeriksson@mandriva.com> 2.2.21-1mdv2012.0
+ Revision: 699748
- 2.2.21

* Thu Sep 01 2011 Oden Eriksson <oeriksson@mandriva.com> 2.2.20-1
+ Revision: 697667
- 2.2.20

* Tue Jun 14 2011 Oden Eriksson <oeriksson@mandriva.com> 2.2.19-1
+ Revision: 684992
- bump release

* Sat May 21 2011 Oden Eriksson <oeriksson@mandriva.com> 2.2.19-0
+ Revision: 676779
- 2.2.19 (pre-release)

* Sat May 14 2011 Oden Eriksson <oeriksson@mandriva.com> 2.2.18-1
+ Revision: 674419
- 2.2.18

* Mon May 02 2011 Oden Eriksson <oeriksson@mandriva.com> 2.2.17-2
+ Revision: 662779
- mass rebuild

* Wed Oct 20 2010 Oden Eriksson <oeriksson@mandriva.com> 2.2.17-1mdv2011.0
+ Revision: 586898
- 2.2.17
- 2.2.17

* Sat Mar 06 2010 Oden Eriksson <oeriksson@mandriva.com> 2.2.15-1mdv2010.1
+ Revision: 515161
- 2.2.15 (official)

* Tue Mar 02 2010 Oden Eriksson <oeriksson@mandriva.com> 2.2.15-0.0mdv2010.1
+ Revision: 513533
- 2.2.15 (pre-release)

* Sun Oct 04 2009 Oden Eriksson <oeriksson@mandriva.com> 2.2.14-1mdv2010.0
+ Revision: 453382
- 2.2.14 was silently released 23-Sep-2009

* Wed Sep 30 2009 Oden Eriksson <oeriksson@mandriva.com> 2.2.14-0.1mdv2010.0
+ Revision: 451694
- 2.2.14 (pre-release)

* Mon Aug 10 2009 Oden Eriksson <oeriksson@mandriva.com> 2.2.13-1mdv2010.0
+ Revision: 414349
- 2.2.13

* Wed Jul 29 2009 Oden Eriksson <oeriksson@mandriva.com> 2.2.12-1mdv2010.0
+ Revision: 402993
- 2.2.12

* Tue Dec 16 2008 Oden Eriksson <oeriksson@mandriva.com> 2.2.11-1mdv2009.1
+ Revision: 314832
- 2.2.11

* Mon Oct 20 2008 Oden Eriksson <oeriksson@mandriva.com> 2.2.10-1mdv2009.1
+ Revision: 295607
- 2.2.10

* Fri Jun 13 2008 Oden Eriksson <oeriksson@mandriva.com> 2.2.9-1mdv2009.0
+ Revision: 218818
- 2.2.9

* Thu Jun 05 2008 Oden Eriksson <oeriksson@mandriva.com> 2.2.8-3mdv2009.0
+ Revision: 215300
- rebuild

* Fri Mar 07 2008 Oden Eriksson <oeriksson@mandriva.com> 2.2.8-2mdv2008.1
+ Revision: 181443
- rebuild

* Fri Jan 18 2008 Oden Eriksson <oeriksson@mandriva.com> 2.2.8-1mdv2008.1
+ Revision: 154719
- 2.2.8 (official release)

* Fri Jan 11 2008 Oden Eriksson <oeriksson@mandriva.com> 2.2.8-0.1mdv2008.1
+ Revision: 147925
- 2.2.8

* Sun Jan 06 2008 Oden Eriksson <oeriksson@mandriva.com> 2.2.7-0.1mdv2008.1
+ Revision: 146091
- fix build
- 2.2.7

  + Olivier Blin <blino@mandriva.org>
    - restore BuildRoot

  + Thierry Vignaud <tv@mandriva.org>
    - kill re-definition of %%buildroot on Pixel's request

* Wed Sep 19 2007 Oden Eriksson <oeriksson@mandriva.com> 2.2.6-2mdv2008.0
+ Revision: 90962
- this is no third party module, so put it in the right place

* Sat Sep 08 2007 Oden Eriksson <oeriksson@mandriva.com> 2.2.6-1mdv2008.0
+ Revision: 82352
- 2.2.6 (release)

* Thu Aug 16 2007 Oden Eriksson <oeriksson@mandriva.com> 2.2.5-0.1mdv2008.0
+ Revision: 64324
- use the new %%serverbuild macro

* Wed Jun 13 2007 Oden Eriksson <oeriksson@mandriva.com> 2.2.4-4mdv2008.0
+ Revision: 38416
- rebuild

